<?php
$refresh = new RefreshModelList();
$refresh->sendHeaders();
echo $refresh->getResults();

//
class RefreshModelList {
    public $availableModels = array ();
    public $modelYear;
    public $make;

    public function __construct() {
        $this->modelYear = $_GET['modelYear'];
        $this->make = $_GET['make'];
        $this->init();
    }

    function sendHeaders() {
        header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
        header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
        header('Content-type: text/xml');
    }

    function getResults() {
        $results = "<models>";
        foreach ($this->availableModels as $mmy) {
            if ($model = $mmy->compareMakeYear($this->make, $this->modelYear)) {
                $results .= "<model>$model</model>";
            }
        }
        $results .= "</models>";
        return $results;
    }

    function init() {
        $this->availableModels[] = new MakeModelYear(2006, "Dodge", "Charger");
        $this->availableModels[] = new MakeModelYear(2006, "Dodge", "Magnum");
        $this->availableModels[] = new MakeModelYear(2006, "Dodge", "Ram");
        $this->availableModels[] = new MakeModelYear(2006, "Dodge", "Viper");
        $this->availableModels[] = new MakeModelYear(1995, "Dodge", "Avenger");
        $this->availableModels[] = new MakeModelYear(1995, "Dodge", "Intrepid");
        $this->availableModels[] = new MakeModelYear(1995, "Dodge", "Neon");
        $this->availableModels[] = new MakeModelYear(1995, "Dodge", "Spirit");
        $this->availableModels[] = new MakeModelYear(1985, "Dodge", "Aries");
        $this->availableModels[] = new MakeModelYear(1985, "Dodge", "Daytona");
        $this->availableModels[] = new MakeModelYear(1985, "Dodge", "Diplomat");
        $this->availableModels[] = new MakeModelYear(1985, "Dodge", "Omni");
        $this->availableModels[] = new MakeModelYear(1970, "Dodge", "Challenger");
        $this->availableModels[] = new MakeModelYear(1970, "Dodge", "Charger");
        $this->availableModels[] = new MakeModelYear(1970, "Dodge", "Coronet");
        $this->availableModels[] = new MakeModelYear(1970, "Dodge", "Dart");
        //
        $this->availableModels[] = new MakeModelYear(2006, "Chevrolet", "Colorado");
        $this->availableModels[] = new MakeModelYear(2006, "Chevrolet", "Corvette");
        $this->availableModels[] = new MakeModelYear(2006, "Chevrolet", "Equinox");
        $this->availableModels[] = new MakeModelYear(2006, "Chevrolet", "Monte Carlo");
        $this->availableModels[] = new MakeModelYear(1995, "Chevrolet", "Beretta");
        $this->availableModels[] = new MakeModelYear(1995, "Chevrolet", "Camaro");
        $this->availableModels[] = new MakeModelYear(1995, "Chevrolet", "Cavalier");
        $this->availableModels[] = new MakeModelYear(1995, "Chevrolet", "Lumina");
        $this->availableModels[] = new MakeModelYear(1985, "Chevrolet", "Cavalier");
        $this->availableModels[] = new MakeModelYear(1985, "Chevrolet", "Chevette");
        $this->availableModels[] = new MakeModelYear(1985, "Chevrolet", "Celebrity");
        $this->availableModels[] = new MakeModelYear(1985, "Chevrolet", "Citation II");
        $this->availableModels[] = new MakeModelYear(1970, "Chevrolet", "Bel Air");
        $this->availableModels[] = new MakeModelYear(1970, "Chevrolet", "Caprice");
        $this->availableModels[] = new MakeModelYear(1970, "Chevrolet", "Chevelle");
        $this->availableModels[] = new MakeModelYear(1970, "Chevrolet", "Monte Carlo");
        //
        $this->availableModels[] = new MakeModelYear(2006, "Pontiac", "G6");
        $this->availableModels[] = new MakeModelYear(2006, "Pontiac", "Grand Prix");
        $this->availableModels[] = new MakeModelYear(2006, "Pontiac", "Solstice");
        $this->availableModels[] = new MakeModelYear(2006, "Pontiac", "Vibe");
        $this->availableModels[] = new MakeModelYear(1995, "Pontiac", "Bonneville");
        $this->availableModels[] = new MakeModelYear(1995, "Pontiac", "Grand Am");
        $this->availableModels[] = new MakeModelYear(1995, "Pontiac", "Grand Prix");
        $this->availableModels[] = new MakeModelYear(1995, "Pontiac", "Firebird");
        $this->availableModels[] = new MakeModelYear(1985, "Pontiac", "6000");
        $this->availableModels[] = new MakeModelYear(1985, "Pontiac", "Fiero");
        $this->availableModels[] = new MakeModelYear(1985, "Pontiac", "Grand Prix");
        $this->availableModels[] = new MakeModelYear(1985, "Pontiac", "Parisienne");
        $this->availableModels[] = new MakeModelYear(1970, "Pontiac", "Catalina");
        $this->availableModels[] = new MakeModelYear(1970, "Pontiac", "GTO");
        $this->availableModels[] = new MakeModelYear(1970, "Pontiac", "LeMans");
        $this->availableModels[] = new MakeModelYear(1970, "Pontiac", "Tempest");
    }
}

//
class MakeModelYear {
    private $modelYear;
    private $make;
    private $model;

    public function __construct($modelYear, $make, $model) {
        $this->modelYear = $modelYear;
        $this->make = $make;
        $this->model = $model;
    }
    public function compareMakeYear($make, $year) {
        if ($year == $this->modelYear && $make == $this->make)
            return $this->model;
        else
            return false;
    }
}
?>