<?php

class php_TaconiteComponent {
    protected $data;

    public function __construct($comp = NULL) {
        $this->data = array('name' => '',
                        'contentName' => '',
                        'contentScript' => '',
                        'title' => '',
                        'position' => '');
        if (is_array($comp)) {
            foreach($comp as $field => $value) {
                $this->$field = $value;
            }
        }                
    }

    public function __set($property, $value) {
        if (array_key_exists($property, $this->data)) {
            $this->data[$property] = $value;
        } else
            print "property $property with value $value, is not set<br/>";
    }

    public function __get($property) {
        if (isset ($this->data[$property])) {
            return $this->data[$property];
        } else {
            return false;
        }
    }

    public function sendHeaders() {
        header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
        header('Content-type: text/xml');
    }
    
    // convenience method to string the parts together for simple windows
    public function createComponentWindow() {
        return $this->createComponentWindowTop().$this->createComponentWindowContent();
    }
    
    public function createComponentWindowTop() {
        $pos = explode(',',$this->data['position']);
        $left = $pos[0];
        $top = $pos[1];
        extract($this->data);
        $windowTop = <<< _WINDOW_TOP_
<div id="${name}Root" style="left:$left; top:$top;">
    <div id="${name}Handle">
        <table width="100%" border="0" class="textbox">
            <tr>
                <td align="left" class="controls">
                    ${title}
                </td>
                <td align="right">
                    <a class="controls" 
                                   href="javascript:minimize('$contentName');">
                        -
                    </a>
                    &nbsp;
                    <a class="controls" 
                                   href="javascript:maximize('$contentName');">
                        +
                    </a>
                </td>
            </tr>
        </table>
    </div>
_WINDOW_TOP_;
        return $windowTop;
    }

    /*
     * method to create the content part of the component. 
     * It also creates the </div> for the component
     */ 
     
    public function createComponentWindowContent() {
        extract($this->data);
        $divstart = "    <div id=\"$contentName\" class=\"$contentName\"> \n";
        // get the output of the content script
        ob_start();
        require $this->contentScript;
        $out = ob_get_contents();
        ob_end_clean();  
          
        $windowBot = <<< _WINDOW_BOT_
    </div>
  </div>

_WINDOW_BOT_;

        return $divstart.$out.$windowBot;       
    }

    // create the Taconite tags to update the content
    public function updateContent() {
        extract($this->data);

        $contentTop = <<< _CONTENT_TOP_
<taconite-root>
    <taconite-replace-children contextNodeID="$contentName" 
                                                             parseInBrowser="true">
_CONTENT_TOP_;
 
        // get the output of the content script
        ob_start();
        require $this->contentScript;
        $out = ob_get_contents();
        ob_end_clean();  
          
        $contentBot = <<< _CONTENT_BOT_
    
    </taconite-replace-children>
    
</taconite-root> 
_CONTENT_BOT_;

        return $contentTop.$out.$contentBot;       
    }

}
?>